//
//  WriteReviewViewController.m
//  iAppsReview
//
//  Created by Kevin McNeish on 5/10/14.
//  Copyright (c) 2014 Oak Leaf Enterprises, Inc. All rights reserved.
//

#import "WriteReviewViewController.h"

@interface WriteReviewViewController ()

@property (weak, nonatomic) IBOutlet UITextField *txtAppName;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *btnShare;
@property (weak, nonatomic) IBOutlet UIImageView *imgThumbnail;
@property (weak, nonatomic) IBOutlet UITextView *tvwReview;
- (IBAction)shareReview:(id)sender;
- (IBAction)accessPhotoLibrary:(id)sender;
- (IBAction)appNameChanged:(id)sender;

@end

@implementation WriteReviewViewController
{
    UIImage *image;
    NSURL *imageURL;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)shareReview:(id)sender {
    
    NSString *reviewText = self.tvwReview.text;
    NSArray *activityItems = [NSArray arrayWithObjects:reviewText, nil];
    UIActivityViewController *avc = [[UIActivityViewController alloc] initWithActivityItems:activityItems applicationActivities:nil];
    [self presentViewController:avc animated:YES completion:nil];
}

- (IBAction)accessPhotoLibrary:(id)sender {
    
    // Create the image picker controller
    UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
    
    // Set the image picker controller properties
    imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    
    // Store a reference to the view controller in the delegate property
    imagePicker.delegate = self;
    
    // Display the image picker controller
    [self presentViewController:imagePicker animated:YES completion:nil];
}

- (IBAction)appNameChanged:(id)sender {
    self.btnShare.enabled = [self isReadyToShare];
}

- (void)textViewDidChange:(UITextView *)textView
{
     self.btnShare.enabled = [self isReadyToShare];
}

- (BOOL)isReadyToShare
{
    // Check if either the text view or the text field is empty
    if (self.tvwReview.text.length == 0 || self.txtAppName.text.length == 0) {
        // One or both of them is empty, disable the button
        return NO;
    }
    else
    {
        // Neither control is empty, enable the button
        return YES;
    }
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    [self dismissViewControllerAnimated:YES completion:nil];
    
    // Get the image and store it in the image view
    image = info[UIImagePickerControllerOriginalImage];
    self.imgThumbnail.image = image;
    
    // Get the URL of the image
    imageURL = info[UIImagePickerControllerReferenceURL];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
    [self dismissViewControllerAnimated:YES completion:nil];
}

@end
